################
# Animat.py    #
# G.Desmeulles #
# 27/07/2022   #
# S2  IPI      #
################
import sys


#le module Animat gere le type abstrait de donnee Animat
#un Animat est un objet qui se deplace dans le terminal 

class Animat:
	pass


def create(color,direction,x,y,x_max,y_max,speed):
	
	#creation animat
	animat=Animat()
	animat.color=color
	animat.direction=direction
	animat.x=x
	animat.y=y
	animat.x_max=x_max
	animat.y_max=y_max
	animat.speed=speed
		
	return animat

def show(a) : 

	#on se place a la position de l animat dans le terminal
	x=str(int(a.x))
	y=str(int(a.y))
	txt="\033["+y+";"+x+"H"
	sys.stdout.write(txt)
	
	#couleur fond noire
	sys.stdout.write("\033[40m")
	
	#couleur animat
	c=a.color
	txt="\033[3"+str(c%7+1)+"m"
	sys.stdout.write(txt)

	#affichage de l animat
	sys.stdout.write("X\n")
	
def move(a,dt):

	#changement de la position de l animat en fonction du pas de temps
	if a.direction=="up":
		a.y=(a.y-(a.speed*dt))%a.y_max
	elif a.direction=="right":
		a.x=(a.x+(a.speed*dt))%a.x_max
	elif a.direction=="down":
		a.y=(a.y+(a.speed*dt))%a.y_max
	elif a.direction=="left":
		a.x=(a.x-(a.speed*dt))%a.x_max
	
def changeColor(a):

	a.color=a.color+1

def changeDirection(a):

	if a.direction=="up":
		a.direction="right"
	elif a.direction=="right":
		a.direction="down"
	elif a.direction=="down":
		a.direction="left"
	elif a.direction=="left":
		a.direction="up"

